<?php

declare(strict_types=1);

namespace hood\vk\robots;

use hood\vk\robots\robot,
    hood\vk\api\longpoll;

use Throwable,
    Exception;

/**
 * Робот-группа
 *
<<<<<<< HEAD
 * $longpoll LongPoll-сессия
 *
 * public function __set($name, $value) Запись свойства
 * public function __get($name) Чтение свойства
 * public function __isset($name) Проверка на инициализированность свойства
 *
 * hood\vk\robots
 * Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
=======
 * @property longpoll $longpoll LongPoll-сессия
 *
 * @method public function __set($name, $value) Запись свойства
 * @method public function __get($name) Чтение свойства
 * @method public function __isset($name) Проверка на инициализированность свойства
 *
 * @package hood\vk\robots
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 */
final class group extends robot
{
    /**
<<<<<<< HEAD
     * $longpoll LongPoll-сессия
=======
     * @var longpoll $longpoll LongPoll-сессия
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected longpoll $longpoll;

    /**
     * Запись свойства
     *
<<<<<<< HEAD
     * $name Название
     * $value Значение
     *
     * @see hood\vk\robots\robot Наследуемый метод
=======
     * @param string $name Название
     * @param mixed $value Значение
     *
     * @see hood\vk\robots\robot Наследуемый метод
     *
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __set(string $name, mixed $value): void
    {
        try {
            parent::__set($name, $value);
        } catch (Throwable $e) {
            // Если свойство не найдено в родительском методе

            match ($name) {
                'longpoll' => $value instanceof LongPoll ? $this->longpoll = $value : $this->longpoll = new LongPoll($this),
                default => throw new Exception($e->getMessage(), $e->getCode(), $e->getPrevious())
            };
        }
    }

    /**
     * Чтение свойства
     *
<<<<<<< HEAD
     * $name Название
     *
     * @see hood\vk\robots\robot Наследуемый метод
=======
     * @param string $name Название
     *
     * @see hood\vk\robots\robot Наследуемый метод
     *
     * @return mixed
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __get(string $name): mixed
    {
        try {
            return parent::__get($name);
        } catch (Throwable $e) {
            // Если свойство не найдено в родительском методе

            if ($name === 'longpoll') {
                if (!isset($this->longpoll)) {
                    $this->longpoll = new LongPoll($this);
                }
                return $this->longpoll;
            }

            throw new Exception($e->getMessage(), $e->getCode(), $e->getPrevious());
        }
    }

    /**
     * Проверка на инициализированность свойства
     *
<<<<<<< HEAD
     * $name Название
     *
     * @return mixed
     */
    public function __isset(string $name)
=======
     * @param string $name Название
     *
     * @return mixed
     */
    public function __isset(string $name): bool
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    {
        try {
            return parent::__isset($name);
        } catch (Throwable $e) {
            // Если свойство не найдено в родительском методе

            if ($name === 'longpoll') {
                return isset($this->longpoll);
            }

            throw new Exception($e->getMessage(), $e->getCode(), $e->getPrevious());
        }
    }
}
